#Admin script

import os
import download_script
import unzip_script
import datetime
import processing_script




#clear screen multiplatform
def cls():
    os.system('cls' if os.name=='nt' else 'clear')

def main_menu():
    print ('1 - Download Imagery')
    print ('2 - Order and unzip downloaded files')
    print ('3 - Utils - Purge imagery folder')
    print ('4 - Utils - Show folders content')
    print ('5 - Processing - Clip rasters')
    print ('6 - Processing - Calculate NBR index')
    print ('7 - Processing - Calculate difference between NBR indexes')
    print ('8 - Processing - Vectorize NBR an NBR difference')
    print ('9 - Upload vector files to PostGIS')
    print ('')
    print ('10 - Batch Processing')
    print ('')
    print ('')
    print ('0 - Exit')
    print ('')
    print ('Select an option')


class CustomError(Exception):
    pass



cls()
print ('')
print ('Welcome to the Admin Script. What do you want to do?')
print ('')
main_menu()


user_choice=input()

while True:

    if user_choice == '1':
        print ('Option 1')

        print ('Enter Year')
        year_=input()
        while True:
            try:
                year_=year_.zfill(4)
                year_test=int(year_)
                if 1900>year_test or int(datetime.datetime.today().year) < year_test:
                    raise CustomError('Please insert a valid year')
                break
            except:
                print ('Enter Year')
                year_=input()

        print ('Enter Month Number')
        month_=input()
        while True:
            try:
                month_=month_.zfill(2)
                month_test=int(month_)
                if 1>month_test or month_test>12 or ((int(datetime.datetime.today().year) == year_test) and int(datetime.datetime.today().month) < month_test):
                    raise CustomError('Please insert a valid month. No future dates allowed')
                break
            except:
                print ('Enter Month Number')
                month_=input()

        print ('Enter Day Number')
        day_=input()
        while True:
            try:
                day_=day_.zfill(2)
                day_test=int(day_)
                date_test=datetime.datetime(year=year_test , month=month_test , day=day_test)
                if date_test > datetime.datetime.today():
                    raise CustomError('Please insert a valid day. No future dates allowed')
                break
            except:
                print ('Enter Day Number')
                day_=input()

        print ('Download imagery? [Y]es / [N]o')
        down_files_=input()
        while down_files_ != 'Y' and down_files_ != 'y' and down_files_ != 'N' and down_files_ != 'n':
            print ('Download imagery? [Y]es / [N]o')
            down_files_=input()
        if down_files_ == 'Y' or down_files_ == 'y':
            down_files_ = True
        else:
            down_files_ = False


        print('Max Clouds in %')
        clouds_=input()
        if not clouds_:
            clouds_="100"
        while True:
            try:
                clouds_=clouds_.zfill(2)
                clouds_test=int(clouds_)
                if 0>clouds_test or clouds_test>100:
                    raise CustomError('Please insert a valid cloud level.')
                break
            except:
                print('Max Clouds in %')
                clouds_=input()

        dt_str=(str(year_)+str(month_)+str(day_))
        print ('Folder name: ', dt_str)
        datetime_string_format = '%Y%m%d'


        try:
            dt_ = datetime.datetime.strptime(dt_str, "%Y%m%d")
        except:
            raise CustomError('Error parsing date. Please check the date is real')
        if (datetime.datetime.today() - dt_).days<0:
            raise CustomError('Images from the future are not available (yet)')



        download_script.download(dt=dt_ , clouds=clouds_ , down_files=down_files_)



    if user_choice == '2':
        print ('Order and unzip')
        unzip_script.order()
        unzip_script.unzip()


    if user_choice == '3':
        print ('Purging...')
        unzip_script.purge_folders()


    if user_choice == '4':
        cls()
        print ('Imagery Folder content:')
        print ('')
        unzip_script.print_tree()
        print ('Press Enter to return...')
        input()
        cls()


    if user_choice == '5':
        system_directory=os.getcwd()
        imagery_directory=os.path.join(system_directory, r'imagery')
        imagery_directory_content=os.listdir(imagery_directory)
        print ('Clip raster files')
        print ('Imagery folder content:')
        print ('')
        unzip_script.print_tree()
        print ('')
        print ('Choose folder. Enter 0 to process every folder not yet processed')
        folder_chosen=input()
        while True:
            if folder_chosen in imagery_directory_content:
                print('')
                print ('Starting clip. This can take up to 10 minutes per file. Be patient...')
                print ('')
                processing_script.clip(folder_chosen)
                break
            if folder_chosen == '0':
                print('')
                print ('Starting clip. This can take up to 10 minutes per file. Be patient...')
                print ('')
                for folders in imagery_directory_content:
                    processing_script.clip(folders)
                break
            else:
                print('')
                print('Unknown folder, please try again. Available folders:')
                print ('')
                unzip_script.print_tree()
                print ('')
                print ('Choose folder. Enter 0 to process every folder not yet processed')
                folder_chosen=input()


    if user_choice == '6':
        system_directory=os.getcwd()
        imagery_directory=os.path.join(system_directory, r'imagery')
        imagery_directory_content=os.listdir(imagery_directory)
        print ('Calculate NBR index')
        print ('Imagery folder content:')
        print ('')
        unzip_script.print_tree()
        print ('')
        print ('Choose folder. Enter 0 to process every folder not yet processed')
        folder_chosen=input()
        while True:
            if folder_chosen in imagery_directory_content:
                print('')
                print ('Starting NBR. Be patient...')
                print ('')
                processing_script.NBR(folder_chosen)
                break
            if folder_chosen == '0':
                print('')
                print ('Starting NBR. Be patient...')
                print ('')
                for folders in imagery_directory_content:
                    processing_script.NBR(folders)
                break
            else:
                print('')
                print('Unknown folder, please try again. Available folders:')
                print ('')
                unzip_script.print_tree()
                print ('')
                print ('Choose folder')
                folder_chosen=input()



    if user_choice == '7':
        system_directory=os.getcwd()
        imagery_directory=os.path.join(system_directory, r'imagery')
        imagery_directory_content=sorted(os.listdir(imagery_directory))
        print ('Difference Between NBR')
        print ('Imagery folder content:')
        print ('')
        unzip_script.print_tree()
        print ('')


        print ('Choose last folder. Enter 0 to process all folders')
        last_folder_chosen=input()
        while True:
            if last_folder_chosen in imagery_directory_content :
                print('')
                print ('Last folder: ', last_folder_chosen)
                print ('')
                break
            elif last_folder_chosen == '0':
                print ('Process all folders')
                break
            else:
                print('')
                print('Unknown folder or same as first, please try again. Available folders:')
                print ('')
                unzip_script.print_tree()
                print ('')
                print ('Choose last folder.')
                last_folder_chosen=input()

        print ('Choose first folder. Enter 0 to automatically match tiles')
        first_folder_chosen=input()
        while True:
            if first_folder_chosen in imagery_directory_content and last_folder_chosen!=first_folder_chosen:
                print('')
                print ('First folder: ', first_folder_chosen)
                print ('')
                break
            elif first_folder_chosen == '0':
                print ('Automatch tiles')
                break
            else:
                print('')
                print('Unknown folder, please try again. Available folders:')
                print ('')
                unzip_script.print_tree()
                print ('')
                print ('Choose first folder. Enter 0 to automatically match tiles')
                first_folder_chosen=input()


        if int(first_folder_chosen)>int(last_folder_chosen):
            first_folder_chosen , last_folder_chosen = last_folder_chosen , first_folder_chosen


        print('First folder chosen: ', first_folder_chosen)
        print('Last folder chosen: ',last_folder_chosen)
        #print('Tile Name: ',tile_name_)
        print('')
        processing_script.difference_NBR(date_last=last_folder_chosen , date_first=first_folder_chosen)



    if user_choice == '8':
        system_directory=os.getcwd()
        imagery_directory=os.path.join(system_directory, r'imagery')
        imagery_directory_content=os.listdir(imagery_directory)
        print ('Vectorize NBR difference files')
        print ('Imagery folder content:')
        print ('')
        unzip_script.print_tree()
        print ('')
        print ('Choose folder. Enter 0 to process every folder not yet processed')
        folder_chosen=input()
        while True:
            if folder_chosen in imagery_directory_content:
                print('')
                print ('Starting. Be patient...')
                print ('')
                processing_script.vector(folder_chosen)
                break
            if folder_chosen == '0':
                print('')
                print ('Starting. Be patient...')
                print ('')
                for folders in imagery_directory_content:
                    processing_script.vector(folders)
                break
            else:
                print('')
                print('Unknown folder, please try again. Available folders:')
                print ('')
                unzip_script.print_tree()
                print ('')
                print ('Choose folder. Enter 0 to process every folder not yet processed')
                folder_chosen=input()




    if user_choice == '9':
        system_directory=os.getcwd()
        imagery_directory=os.path.join(system_directory, r'imagery')
        imagery_directory_content=os.listdir(imagery_directory)
        print ('Upload Vector Files to PostGIS')
        print ('Imagery folder content:')
        print ('')
        unzip_script.print_tree()
        print ('')
        print ('Choose folder. Enter 0 to process every folder not yet processed')
        folder_chosen=input()
        while True:
            if folder_chosen in imagery_directory_content:
                print('')
                print ('Starting. Be patient...')
                print ('')
                processing_script.load_postgis(folder_chosen)
                break
            if folder_chosen == '0':
                print('')
                print ('Starting. Be patient...')
                print ('')
                for folders in imagery_directory_content:
                    processing_script.load_postgis(folders)
                break
            else:
                print('')
                print('Unknown folder, please try again. Available folders:')
                print ('')
                unzip_script.print_tree()
                print ('')
                print ('Choose folder. Enter 0 to process every folder not yet processed')
                folder_chosen=input()



    if user_choice=='10':

        print('')
        print('This option allows to set up an automated download and processing between two dates.')


        #date from
        print ('Date from: Enter Year')
        year_=input()
        while True:
            try:
                year_=year_.zfill(4)
                year_test=int(year_)
                if 1900>year_test or int(datetime.datetime.today().year) < year_test:
                    raise CustomError('Please insert a valid year')
                break
            except:
                print ('Date from: Enter Year')
                year_=input()

        print ('Date from: Enter Month Number')
        month_=input()
        while True:
            try:
                month_=month_.zfill(2)
                month_test=int(month_)
                if 1>month_test or month_test>12 or ((int(datetime.datetime.today().year) == year_test) and int(datetime.datetime.today().month) < month_test):
                    raise CustomError('Please insert a valid month. No future dates allowed')
                break
            except:
                print ('Date from: Enter Month Number')
                month_=input()

        print ('Date from: Enter Day Number')
        day_=input()
        while True:
            try:
                day_=day_.zfill(2)
                day_test=int(day_)
                date_test=datetime.datetime(year=year_test , month=month_test , day=day_test)
                if date_test > datetime.datetime.today():
                    raise CustomError('Please insert a valid day. No future dates allowed')
                break
            except:
                print ('Date from: Enter Day Number')
                day_=input()



        #date to
        print()
        print ('Date to: Enter Year')
        year_to=input()
        while True:
            try:
                year_to=year_to.zfill(4)
                year_totest=int(year_to)
                if 1900>year_totest or int(datetime.datetime.today().year) < year_totest:
                    raise CustomError('Please insert a valid year')
                break
            except:
                print ('Date to: Enter Year')
                year_to=input()

        print ('Date to: Enter Month Number')
        month_to=input()
        while True:
            try:
                month_to=month_to.zfill(2)
                month_totest=int(month_to)
                if 1>month_totest or month_totest>12 or ((int(datetime.datetime.today().year) == year_totest) and int(datetime.datetime.today().month) < month_totest):
                    raise CustomError('Please insert a valid month. No future dates allowed')
                break
            except:
                print ('Date to: Enter Month Number')
                month_to=input()

        print ('Date to: Enter Day Number')
        day_to=input()
        while True:
            try:
                day_to=day_to.zfill(2)
                day_totest=int(day_to)
                date_test=datetime.datetime(year=year_test , month=month_test , day=day_test)
                if date_test > datetime.datetime.today():
                    raise CustomError('Please insert a valid day. No future dates allowed')
                break
            except:
                print ('Date from: Enter Day Number')
                day_to=input()



        #check dates
        dt_str=(str(year_)+str(month_)+str(day_))
        dt_tostr=(str(year_to)+str(month_to)+str(day_to))


        datetime_string_format = '%Y%m%d'


        try:
            dt_ = datetime.datetime.strptime(dt_str, "%Y%m%d")
            dt_to = datetime.datetime.strptime(dt_tostr, "%Y%m%d")
        except:
            raise CustomError('Error parsing date. Please check the date is real')

        if dt_>dt_to:
            raise CustomError('Date from is more recent than date to')


        if (datetime.datetime.today() - dt_).days<0 or (datetime.datetime.today() - dt_to).days<0:
            raise CustomError('Images from the future are not available (yet)')




        print ('Download imagery? [Y]es / [N]o')
        down_files_=input()
        while down_files_ != 'Y' and down_files_ != 'y' and down_files_ != 'N' and down_files_ != 'n':
            print ('Download imagery? [Y]es / [N]o')
            down_files_=input()
        if down_files_ == 'Y' or down_files_ == 'y':
            down_files_ = True
        else:
            down_files_ = False


        print('Max Clouds in %')
        clouds_=input()
        if not clouds_:
            clouds_="100"
        while True:
            try:
                clouds_=clouds_.zfill(2)
                clouds_test=int(clouds_)
                if 0>clouds_test or clouds_test>100:
                    raise CustomError('Please insert a valid cloud level.')
                break
            except:
                print('Max Clouds in %')
                clouds_=input()


       #For the given period, proceed with the whole processing
        while dt_ < dt_to:
            download_script.download(dt=dt_ , clouds=clouds_ , down_files=down_files_)
            unzip_script.order()
            unzip_script.unzip()
            system_directory=os.getcwd()
            imagery_directory=os.path.join(system_directory, r'imagery')
            imagery_directory_content=os.listdir(imagery_directory)
            dt_yest= dt_ - datetime.timedelta(days=1)
            folders = dt_yest.date().strftime(datetime_string_format)

            processing_script.clip(folders)

            processing_script.NBR(folders)
            imagery_directory_content=os.listdir(imagery_directory)

            processing_script.difference_NBR(date_last=folders , date_first='0')

            processing_script.vector(folders)

            processing_script.load_postgis(folders)

            dt_ += datetime.timedelta(days=1)







    if user_choice == '0':
        print ('Exit')
        break


    else:

        print ('')
        print ('What do you want to do?')
        print ('')
        main_menu()
        user_choice=input()



