#Download Script. Carlos Sarille 2018


import datetime
import os

system_directory=os.getcwd()
auth_file_path=os.path.join(system_directory, r'apihub.txt')
mask_folder_path=os.path.join(system_directory, r'shape')
mask_file_path=os.path.join(mask_folder_path, r'mask.geojson')


class CustomError(Exception):
    pass



def download(dt, clouds, down_files):

    try:
        auth_file=open(auth_file_path, 'r')
        username=auth_file.readline().strip('\n')
        password=auth_file.readline().strip('\n')
        auth_file.close()
    except:
        raise CustomError('No apihub.txt file in main folder or corrupted file. Format: 1st line username, 2nd line password.')

    datetime_string_format = '%Y%m%d'

    dt_ant = dt - datetime.timedelta(days=1)
    dt_ant_str = dt_ant.date().strftime(datetime_string_format)
    dt_str=dt.date().strftime(datetime_string_format)


    #check for clouds
    cloud_index=int(clouds)
    if (cloud_index < 0) or (cloud_index > 100):
        raise CustomError('Cloud coverage index must be between 0 and 100')
    if (cloud_index==100):
        clouds_=""
    else:
        clouds_=" --cloud "+str(cloud_index).zfill(2)


    print ("")
    print ("")
    print ("----------------------------------------------------------------")
    print ('Download Script')
    print ('Please make sure that apihub.txt file exists in the main folder containing your username and password')
    print ("")
    print ("Date to: ", dt_str)
    print ("Date from: ", dt_ant_str)
    print ("Max Clouds: ", clouds_)
    print ("")
    print ("Executing Sentinel Sat...")
    print ("")
    print ("")




    #organize the input and call the Sentinel Dowload

    if (down_files is False):
        lista=""
    else:
        lista="-d "



    sentinel_command='sentinelsat  -u '+username+' -p '+password+' -g "'+mask_file_path+'" -s '+dt_ant_str+' -e '+dt_str+clouds_+' --sentinel 2 --producttype S2MSI1C '+lista
    print ("Executing:", sentinel_command)
    os.system(sentinel_command)

    print ('')
    print ('Download finished')




