#Scrip to tidy up the root directory and unzip the new files
import os
import shutil




system_directory=os.getcwd()
imagery_directory=os.path.join(system_directory,r'imagery')
if not os.path.exists(imagery_directory):
    print ('Directory "imagery" has been created')
    os.makedirs(imagery_directory)


#function that moves .SAFE.zip files to imagery folder

def order():
    print ('')
    print ('Ordering Directories')
    print ('')


    print('Current system directory: ', str(system_directory))
    current_directory_content=os.listdir(system_directory)

    #creates imagery directory if it doesn't exist
    if not os.path.exists(imagery_directory):
        print ('Directory "imagery" has been created')
        os.makedirs(imagery_directory)
    else:
        print('The folder',str(imagery_directory),' already exists')

    print('')
    print('The following files have been moved to /imagery:')
    for name in current_directory_content:
        name_chunks=name.split('.')
        if name_chunks[-1] == 'zip':
            print (name)
            current_file=os.path.join(system_directory,name)
            moved_file=os.path.join(imagery_directory,name)
            os.rename(current_file,moved_file)



#function that checks if there is something inside dates folder and if not, removes them

def purge_folders():
    print('')
    print('Checking folders')
    print('')


    print('Current working directory: ', str(system_directory))
    print('Imagery directory: ', str(imagery_directory))
    current_directory_content=os.listdir(imagery_directory)


    #creates imagery directory if it doesn't exist
    if os.path.exists(imagery_directory):
        print ('Checking imagery folder...')
        for name in current_directory_content:
            folder_date_path=os.path.join(imagery_directory,name)
            for path,subdir,files in os.walk(folder_date_path):
                if not files:
                    os.rmdir(folder_date_path)
                    print(name, ' was empty. Deleted.')

    else:
        print('The folder',str(imagery_directory)," doesn't exists. Nothing to purge.")


def print_tree():
    for root, dirs, files in os.walk(imagery_directory):
        level = root.replace(imagery_directory, '').count(os.sep)
        indent = ' ' * 4 * (level)
        print('{}{}/'.format(indent, os.path.basename(root)))
        subindent = ' ' * 4 * (level + 1)
        for f in files:
            print('{}{}'.format(subindent, f))



#function that unzips the imagery files

def unzip():
    print ('')
    print ('Unziping files')
    print ('')


    if not os.path.exists(imagery_directory):
        os.makedirs(imagery_directory)
        print ('Directory',str(imagery_directory) ,'has been created')

    print('Current working directory: ', str(imagery_directory))
    current_directory_content=os.listdir(imagery_directory)

    for name in current_directory_content:
        name_format=name.split('.')
        if name_format[-1] == 'zip': #check if the file format is .zip

            name_parts=name_format[-2].split('_')
            name_date=name_parts[2].split('T')
            final_folder=os.path.join(imagery_directory,name_date[0])
            temp_folder=os.path.join(imagery_directory,r'temp')
            if not os.path.exists(final_folder): #check if there is a folder for that same date
                print ('Directory',str(final_folder) ,'has been created')
                os.makedirs(final_folder)
            if not os.path.exists(temp_folder): #check if there is a folder for that same date
                print ('Directory',str(temp_folder) ,'has been created')
                os.makedirs(temp_folder)

            zip_file=os.path.join(imagery_directory,name)
            unzip_path_linux=r"unzip "+str(zip_file)+" -d "+str(temp_folder)
            unzip_path_windows=r'winrar x -ibck -o+ "'+str(zip_file)+'" "'+str(temp_folder)+'" -INUL'
            os.system(unzip_path_windows if os.name=='nt' else unzip_path_linux) #extract the whole file to a temporary folder

            #find the wanted files and move them to the definitive folder

            for path,subdir,files in os.walk(temp_folder):
                for name2 in files:
                    fileformat=name2.split('.')
                    if fileformat[-1] == 'jp2':
                        band_type=fileformat[-2].split('_')
                        if band_type[-1] == 'B08' or band_type[-1] == 'B12':
                            if os.path.isfile(os.path.join(final_folder,name2)):
                                os.remove(os.path.join(final_folder,name2))
                            os.rename(os.path.join(path,name2),os.path.join(final_folder,name2))
                    if fileformat[-1] == 'gml':
                        band_type=fileformat[-2].split('_')
                        if band_type[-2] == 'CLOUDS':
                            new_name=str(name_parts[-2]+'_'+name_date[0]+'_'+name2)
                            if os.path.isfile(os.path.join(final_folder,new_name)):
                                os.remove(os.path.join(final_folder,new_name))
                            os.rename(os.path.join(path,name2),os.path.join(final_folder,new_name))


            this_original_zip=os.path.join(imagery_directory,name)
            os.remove(this_original_zip)
            shutil.rmtree(temp_folder)
            print ('')
            print ('Unzip finished')
            print ('')



















