var wms_catastro = 'http://ovc.catastro.meh.es/cartografia/INSPIRE/spadgcwms.aspx';
var wms_URL = 'http://localhost:8080/geoserver/TFG/wms';
var wms_getcapabilities_URL = 'http://localhost:8080/geoserver/TFG/wms?request=getcapabilities'
var zoom_catastro = 15;
var zoom_button = 14;
var dates;
var date_from;
var date_to;


//pedimos getcapabilities e extraemos as datas límite
$.ajax({
        type: "GET",
        async: false,
		url: wms_getcapabilities_URL,
		dataType: "xml",
		success: function(xml) {
                var xml_node = $('WMS_Capabilities',xml);
                dates=xml_node.find('Capability > Layer > Layer[queryable="1"] > Dimension[name="time"]').text();

        },
        error: function(data){
        console.log('Error loading XML data');
        }
});


console.log(dates);
var dates_string=String(dates);
var dates_array = dates_string.split(',');

date_from=dates_array[0];
date_to=dates_array.pop();

var interval=date_from+'/'+date_to;

//map creation
var map = L.map('map',{
	  contextmenu: true,
      contextmenuWidth: 200,
	  contextmenuItems: [{
	    text: 'How to get here',
	    callback: como_chegar
  }
	,  '-',{
	    text: 'Center here',
	    callback: centerMap
	}, {
	    text: 'Zoom in',
	    callback: zoomIn
	}, {
	    text: 'Zoom out',
	    callback: zoomOut
	}, '-',{
      text: 'Restart Webmap',
      callback: reiniciar_visor
  }],
    timeDimension: true,
    timeDimensionOptions: {
        timeInterval: interval,
        period: "P1D"
    },
    timeDimensionControl: true,
}).setView([42.8 , -8] , 8)


var baseBounds = map.getBounds();



function getCoordinates (e) {
	return e.latlng;
}

function centerMap (e) {
	map.panTo(e.latlng);
}

function zoomIn (e) {
	map.zoomIn();
}

function zoomOut (e) {
	map.zoomOut();
}







/******CAPAS******/

//cargamos capa base satélite
var options_bing = {
  bingMapsKey: 'ApWc1GvXN7a4LGPyvpolzQohUqHSDlbv4598PxCv_djXjfO5lb2YnJIWppQx1x75',
  imagerySet: 'Aerial',
  culture: 'gl'
  }

  var baselayer = L.tileLayer.bing(options_bing).addTo(map);


//Base Toner
  var toner_layer = L.tileLayer('http://stamen-tiles-{s}.a.ssl.fastly.net/toner/{z}/{x}/{y}.png', {
        attribution: 'Map tiles by <a href="http://stamen.com">Stamen Design</a>, <a href="http://creativecommons.org/licenses/by/3.0">CC BY 3.0</a> &mdash; Map data &copy; <a href="http://www.openstreetmap.org/copyright">OpenStreetMap</a>',
        subdomains: 'abcd',
        minZoom: 0,
        maxZoom: 20,
        ext: 'png'
    });

//OSM base
  var layer_OSM = L.tileLayer('http://{s}.tile.openstreetmap.org/{z}/{x}/{y}.png', {
    maxZoom: 18
  });


//WMS CATASTRO
var layer_catastro_wms = L.tileLayer.wms(wms_catastro, {
    layers: 'cp.cadastralparcel',
    format: 'image/png',
    transparent: true
});


//WMS temporal
var layer_nbr_diff = L.tileLayer.wms(wms_URL, {
    tiled: true,
    srs: 'EPSG:4326',
    layers: 'TFG:nbr_diff',
    format: 'image/png',
    transparent: true,
    opacity: 0.65
});

var tdWmsLayer = L.timeDimension.layer.wms(layer_nbr_diff);


var layer_nbr = L.tileLayer.wms(wms_URL, {
    tiled: true,
    srs: 'EPSG:4326',
    layers: 'TFG:nbr',
    format: 'image/png',
    transparent: true,
    opacity: 0.6
});

var td2WmsLayer = L.timeDimension.layer.wms(layer_nbr);
td2WmsLayer.addTo(map);










var baseMaps = {
    "Satellite": baselayer,
    "Toner": toner_layer,
    "Map": layer_OSM
};

var overlayMaps = {
    "Catastro": layer_catastro_wms,
    "NBR index":td2WmsLayer,
    "NBR Difference": tdWmsLayer
};

L.control.layers(baseMaps, overlayMaps).addTo(map);

function como_chegar(coordinates){


  var gmaps = "https://www.google.com/maps/search/?api=1&query=";
  var coord = coordinates.latlng;
    console.log (coord);
  var coordenadas = String(coord).split(',');
    console.log (coordenadas);
  var lng = String(parseFloat(coordenadas[1].substring(1 , (coordenadas[1].length -1 ))));
  var lat = String(parseFloat(coordenadas[0].substring(7 , (coordenadas[0].length))));
  var coordenadasurl = lat.concat("," , lng);


  var url = gmaps+coordenadasurl;
  console.log(url);
  window.open(url);

}


//minimapa
var osm2 = new L.tileLayer('http://{s}.tile.openstreetmap.org/{z}/{x}/{y}.png', {
    maxZoom: 18
  });
var miniMap = new L.Control.MiniMap(osm2, { toggleDisplay: true , position: 'bottomright' , zoomLevelOffset: -4 , width: 250 , strings: {
				hideText: 'Hide map',
				showText: 'Show map'
			}}).addTo(map);




//Activar/desactivar todas as capas

var higherOpacity = new L.Control.higherOpacity();
map.addControl(higherOpacity);
var lowerOpacity = new L.Control.lowerOpacity();
map.addControl(lowerOpacity);
higherOpacity.setOpacityLayer(td2WmsLayer);





function reiniciar_visor(){
      map.setView([42.8 , -8] , 8);}



map.contextmenu.setDisabled(7 , true);
map.contextmenu.setDisabled(0 , true);
map.contextmenu.setDisabled(1 , true);


map.on('zoomend',function () {
    if (map.getZoom() < zoom_catastro) {
        //control.unSelectLayer( layer_catastro_wms );
    }

    if (map.getZoom() <= zoom_button) {
        map.contextmenu.setDisabled(7 , true);
    } else {map.contextmenu.setDisabled(7 , false);}

    if (map.getZoom() <= 11) {
        map.contextmenu.setDisabled(0 , true);
        map.contextmenu.setDisabled(1 , true);
    } else {map.contextmenu.setDisabled(0 , false); map.contextmenu.setDisabled(1 , false);}


    });




















